import Console from "./Console";
import Printable from "./Printable";
import Classname from "./Classname";
import * as list from "../list/index";
declare class DOMConsole implements Console {
    private _el;
    constructor();
    error(e: Error): void;
    print(value: Printable): void;
    private listToTable(data);
    private arrayToTable(data);
    private objectToTable(data);
    image(url: string): void;
    promptNumber(prompt: string): Promise<number>;
    promptString(prompt: string): Promise<string>;
    promptBoolean(prompt: string): Promise<boolean>;
    csvToArray<T>(prompt: string, classname: Classname<T>): Promise<T[]>;
    csvToList<T>(prompt: string, classname: Classname<T>): Promise<list.List<T>>;
    private ask(prompt, type, validator, parser, cb);
    clear(): void;
    random(floor: number, ceiling: number): number;
    setInterval(cb: () => void, duration: number): number;
    private getType(value);
    private append(el);
}
export default DOMConsole;
