import Console from "./Console";
import Printable from "./Printable";
import Classname from "./Classname";
import { List } from "../list";
declare function print(s: Printable): void;
declare function image(url: string): void;
declare function promptNumber(prompt: string): Promise<number>;
declare function promptString(prompt: string): Promise<string>;
declare function promptBoolean(prompt: string): Promise<boolean>;
declare function csvToArray<T>(prompt: string, classname: Classname<T>): Promise<T[]>;
declare function csvToList<T>(prompt: string, classname: Classname<T>): Promise<List<T>>;
declare function clear(): void;
declare function random(floor: number, ceiling: number): number;
declare function error(e: Error): void;
declare function setInterval(cb: () => void, duration: number): number;
declare function setConsole(console: Console): void;
export { print, image, clear, random, promptNumber, promptString, promptBoolean, csvToArray, csvToList, error, setInterval, setConsole };
