import Console from "../Console";
import Printable from "../Printable";
import Session from "./Session";
import Classname from "../Classname";
import * as list from "../../list";
declare class TestConsole implements Console {
    private _expected;
    private _actual;
    private _testing;
    constructor();
    readonly actual: Session;
    expected: Session;
    testing: boolean;
    print(s: Printable): void;
    image(url: string): void;
    promptNumber(prompt: string, response?: number): Promise<number>;
    promptString(prompt: string, response?: string): Promise<string>;
    promptBoolean(prompt: string, response?: boolean): Promise<boolean>;
    csvToArray<T>(prompt: string, classname: Classname<T>, response?: T[]): Promise<T[]>;
    csvToList<T>(prompt: string, classname: Classname<T>): Promise<list.List<T>>;
    setInterval(cb: () => void, duration: number): number;
    clear(): void;
    random(floor: number, ceiling: number): number;
    error(e: Error): void;
}
export default TestConsole;
