import Transform from "./Transform";
import Observable from "../events/Observable";
import Observer from "../events/Observer";
export default abstract class SVGElement implements Observable<SVGElement> {
    private _observers;
    private _transform;
    onclick: (event: MouseEvent) => void;
    ondblclick: (event: MouseEvent) => void;
    onmousemove: (event: MouseEvent) => void;
    onmousedown: (event: MouseEvent) => void;
    onmouseup: (event: MouseEvent) => void;
    onmouseover: (event: MouseEvent) => void;
    onmouseout: (event: MouseEvent) => void;
    addObserver(observer: Observer<SVGElement>): void;
    clearObservers(): void;
    removeObserver(observer: Observer<SVGElement>): void;
    notify(): void;
    toString(): string;
    transform: Transform;
}
