"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Transform_1 = require("./Transform");
var SVGElement = (function () {
    function SVGElement() {
        this._observers = [];
        this._transform = Transform_1.default.DEFAULT;
        this.onclick = function (event) { };
        this.ondblclick = function (event) { };
        this.onmousemove = function (event) { };
        this.onmousedown = function (event) { };
        this.onmouseup = function (event) { };
        this.onmouseover = function (event) { };
        this.onmouseout = function (event) { };
    }
    SVGElement.prototype.addObserver = function (observer) {
        this._observers.push(observer);
    };
    SVGElement.prototype.clearObservers = function () {
        this._observers = [];
    };
    SVGElement.prototype.removeObserver = function (observer) {
        this._observers = this._observers.filter(function (o) { return o !== observer; });
    };
    SVGElement.prototype.notify = function () {
        var _this = this;
        this._observers.forEach(function (observer) { return observer(_this); });
    };
    SVGElement.prototype.toString = function () {
        return "SVGElement";
    };
    Object.defineProperty(SVGElement.prototype, "transform", {
        get: function () {
            return this._transform;
        },
        set: function (t) {
            this._transform = t;
            this.notify();
        },
        enumerable: true,
        configurable: true
    });
    return SVGElement;
}());
exports.default = SVGElement;
//# sourceMappingURL=SVGElement.js.map