"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CommandQueue = (function () {
    function CommandQueue() {
        this.head = null;
        this.tail = null;
    }
    CommandQueue.prototype.current = function () {
        if (this.head) {
            return this.head;
        }
        else {
            throw new Error("The command queue is empty!");
        }
    };
    CommandQueue.prototype.enqueue = function (command) {
        if (this.head === null) {
            this.head = command;
        }
        if (this.tail !== null) {
            this.tail.next = command;
        }
        this.tail = command;
    };
    CommandQueue.prototype.hasNext = function () {
        return this.head !== null;
    };
    CommandQueue.prototype.isEmpty = function () {
        return this.head === null;
    };
    CommandQueue.prototype.next = function () {
        if (this.head !== null) {
            var command = this.head;
            this.head = this.head.next;
            return command;
        }
        else {
            throw new Error("The command queue is empty");
        }
    };
    return CommandQueue;
}());
exports.CommandQueue = CommandQueue;
//# sourceMappingURL=CommandQueue.js.map